searchData={"items":[{"type":"module","title":"AshOutstanding.Expressions.IsOutstanding","doc":"","ref":"AshOutstanding.Expressions.IsOutstanding.html"},{"type":"function","title":"AshOutstanding.Expressions.IsOutstanding.arguments/0","doc":"Callback implementation for  Ash.CustomExpression.arguments/0 .","ref":"AshOutstanding.Expressions.IsOutstanding.html#arguments/0"},{"type":"function","title":"AshOutstanding.Expressions.IsOutstanding.expression/2","doc":"Callback implementation for  Ash.CustomExpression.expression/2 .","ref":"AshOutstanding.Expressions.IsOutstanding.html#expression/2"},{"type":"function","title":"AshOutstanding.Expressions.IsOutstanding.is_outstanding/2","doc":"Computes is_outstanding on two terms using Outstanding protocol","ref":"AshOutstanding.Expressions.IsOutstanding.html#is_outstanding/2"},{"type":"function","title":"AshOutstanding.Expressions.IsOutstanding.name/0","doc":"Callback implementation for  Ash.CustomExpression.name/0 .","ref":"AshOutstanding.Expressions.IsOutstanding.html#name/0"},{"type":"function","title":"AshOutstanding.Expressions.IsOutstanding.predicate?/0","doc":"","ref":"AshOutstanding.Expressions.IsOutstanding.html#predicate?/0"},{"type":"module","title":"AshOutstanding.Expressions.Outstanding","doc":"","ref":"AshOutstanding.Expressions.Outstanding.html"},{"type":"function","title":"AshOutstanding.Expressions.Outstanding.arguments/0","doc":"Callback implementation for  Ash.CustomExpression.arguments/0 .","ref":"AshOutstanding.Expressions.Outstanding.html#arguments/0"},{"type":"function","title":"AshOutstanding.Expressions.Outstanding.expression/2","doc":"Callback implementation for  Ash.CustomExpression.expression/2 .","ref":"AshOutstanding.Expressions.Outstanding.html#expression/2"},{"type":"function","title":"AshOutstanding.Expressions.Outstanding.name/0","doc":"Callback implementation for  Ash.CustomExpression.name/0 .","ref":"AshOutstanding.Expressions.Outstanding.html#name/0"},{"type":"function","title":"AshOutstanding.Expressions.Outstanding.outstanding/2","doc":"Computes outstanding on two terms using Outstanding protocol","ref":"AshOutstanding.Expressions.Outstanding.html#outstanding/2"},{"type":"function","title":"AshOutstanding.Expressions.Outstanding.predicate?/0","doc":"","ref":"AshOutstanding.Expressions.Outstanding.html#predicate?/0"},{"type":"module","title":"AshOutstanding.Resource","doc":"Ash resource extension for implementing `Outstanding` protocol.","ref":"AshOutstanding.Resource.html"},{"type":"macro","title":"AshOutstanding.Resource.outstanding/1","doc":"","ref":"AshOutstanding.Resource.html#outstanding/1"},{"type":"module","title":"AshOutstanding.Union","doc":"Outstanding protocol implementation for Ash.Union :type_and_value.","ref":"AshOutstanding.Union.html"},{"type":"extras","title":"AshOutstanding","doc":"# AshOutstanding\n\n[![Module Version](https://img.shields.io/hexpm/v/ash_outstanding)](https://hex.pm/packages/ash_outstanding)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen)](https://hexdocs.pm/ash_outstanding/)\n[![License](https://img.shields.io/hexpm/l/ash_outstanding)](https://github.com/diffo-dev/ash_outstanding/blob/master/LICENSE.md)\n\nAsh resource extension for implementing `Outstanding` protocol, which by default is deliberately not implemented for custom structs.\n\nImplementing Outstanding on your Ash Resources is useful when you have an expected / actual twin, and want to establish whether/which expectations are outstanding given actual.\n\nThis is a powerful concept, particularly as expectations are declarations of intent, and we want to separate the concerns of whether we've sufficiently met our expectations from how to deal with what is outstanding. Ash itself is highly declarative, creating and exploiting Spark DSL. \n\nThis extension employs Spark DSL to allow you to declare how your Ash Resource should implement Outstanding.","ref":"readme.html"},{"type":"extras","title":"Installation - AshOutstanding","doc":"Add to the deps:\n\n```elixir\ndef deps do\n  [\n    {:ash_outstanding, \"~> 0.2.0\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - AshOutstanding","doc":"Add `AshOutstanding.Resource` to `extensions` list within `use Ash.Resource` options:\n\n```elixir\ndefmodule Example.Resource do\n  use Ash.Resource,\n    extensions: [AshOutstanding.Resource]\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - AshOutstanding","doc":"Generally you will want to configure your Ash Resource so that outstanding?(expected, actual) is true when the essentials of your Ash Resource are satisfied. This may align to expecting actual to sufficiently attributes which are mandatory and/or fundamental to Ash identities. These attributes are configured using the expect list.\n\n- expect, provide list of Ash Record fields which can have have expectations\n\nHere is an example `outstanding` dsl section, which configures a Specification resource so that we can set expectations on any or all of the values of keys :name, :major_version and :version while ignoring other fields in the expected/actual resource.\nWhen nil_outstanding?(expected, actual) is true, outstanding(expected, actual) returns nil\nWhen nil_outstanding?(expected, actual) is false, outstanding(expected, actual) returns a struct of your Ash Record with just the unmet expectations.\n\n```elixir\ndefmodule Specification.Resource do\n  use Ash.Resource,\n    extensions: [AshOutstanding.Resource]\n\n  outstanding do\n    expect [:name, :major_version, :version]\n  end\nend\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Using Outstanding on your resource - AshOutstanding","doc":"We don't need to set all of the expectations, by default a missing expectation or explict nil means we have no expectation (so nothing will be outstanding)\n\nIn the following example we require the access specification to be major version 2. We don't match version as we aren't concerned with minor or trival versions.\n```elixir\nuse Outstand\n\nexpected = %Specification.Resource{name: access, major_version: 2}\nactual = %Specification.Resource{name: access, major_version: 1}\nexpected >>> actual\nfalse\nexpected --- actual\n%Specification.Resource{major_version: 2}\n```\n\nIf we are happy with either major_version: 1 or 2, we can use a range\n\n```elixir\nuse Outstand\nexpected = %Specification.Resource{name: access, major_version: 1..2}\nactual = %Specification.Resource{name: access, major_version: 1}\nexpected >>> actual\ntrue\nexpected --- actual\nnil\n```\n\nOutstanding supports regex, here we use a regex to expect version: is at least v1.1\nWe don't need an expectation on major version.\n\n```elixir\nuse Outstand\nexpected = %Specification.Resource{name: access, version: ~r/v1.1/}\nactual = %Specification.Resource{name: access, version: v1.1.17}\nexpected >>> actual\ntrue\nexpected --- actual\nnil\n```\n\nOutstanding supports expected functions. Arity 1 and 2 expected functions use actual as a parameter. Arity 2 expected functions take an argument list, and this can be a list of 'prototype' expected resources used in an Outstand or your own expected function.\n\nYou may need to ensure your expected/actual Ash Resources are appropriately loaded, depending on what key/values you expect.","ref":"readme.html#using-outstanding-on-your-resource"},{"type":"extras","title":"Customize - AshOutstanding","doc":"A dsl option is provided which will insert a custom arity 3 function into the outstanding pipeline.\n\nBelow customize is used to ensure that outstanding is enriched with expected.id\n\n```elixir\ndefmodule Specification.Resource do\n  use Ash.Resource,\n    extensions: [AshOutstanding.Resource]\n\n  outstanding do\n    expect [:name, :major_version, :version]\n    customize fn outstanding, expected, _actual ->\n      case outstanding do\n        nil ->\n          outstanding\n        %_{} ->\n          outstanding\n          |> Map.put(:id, expected.id)\n      end\n    end\n  end\nend\n```","ref":"readme.html#customize"},{"type":"extras","title":"Using Outstanding in Ash Expressions - AshOutstanding","doc":"Ash Expressions can call outstanding(expected, actual) and is_outstanding(expected, actual) via custom expressions. This is particularly useful when combined with relationships, as a supervising resource can manage its expectations of a supervised resource.\n\nAshOutstanding includes the Outstanding and IsOutstanding custom expressions for the Ash.DataLayer.Simple and Ash.DataLayer.ETS.\n\nThese must be configured in your config.exs:\n```elixir\nconfig :ash, :custom_expressions, [AshOutstanding.Expressions.Outstanding, AshOutstanding.Expressions.IsOutstanding]\n```","ref":"readme.html#using-outstanding-in-ash-expressions"},{"type":"extras","title":"Acknowledgements - AshOutstanding","doc":"Thanks to [Dmitry Maganov](https://github.com/vonagam) for [ash_jason](https://github.com/vonagam/ash_jason) which was an exemplar.\n\nKudos to the [Ash Core](https://github.com/ash-project) for [ash](https://github.com/ash-project/ash) 🚀","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Links - AshOutstanding","doc":"[Diffo.dev](https://www.diffo.dev))\n[`Outstanding` protocol docs](https://hexdocs.pm/outstanding/)\n[`Outstanding` protocol livebook] (https://livebook.dev/run/?url=https%3A%2F%2Fgithub.com%2Fdiffo-dev%2Foutstanding%2Fblob%2Fdev%2Foutstanding.livemd)","ref":"readme.html#links"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}